import pygame
import sys

#変数定義
プッシュフラグ=0
番号=0
ネコ座標=pygame.Rect(600,340,0,0)

#pygame初期化
pygame.init()

スクリーン = pygame.display.set_mode((800,600))
スクリーン.fill("white")

#画像アップロード
背景=pygame.image.load("image\背景.png")
城=pygame.image.load("image\城.png")
城_敵=pygame.image.load("image\城_敵.png")
ネコ=pygame.image.load("image\ネコ\ネコ.png")
歩く1=pygame.image.load("image\ネコ\歩く1.png")
歩く2=pygame.image.load("image\ネコ\歩く2.png")
歩く3=pygame.image.load("image\ネコ\歩く3.png")
歩く4=pygame.image.load("image\ネコ\歩く4.png")

#画像サイズ変更
城=pygame.transform.scale(城,(84,200))
城_敵=pygame.transform.scale(城_敵,(92,200))
ネコボタン=pygame.transform.scale(ネコ,(80,65))
歩く1=pygame.transform.scale(歩く1,(60,66))
歩く2=pygame.transform.scale(歩く2,(60,66))
歩く3=pygame.transform.scale(歩く3,(60,66))
歩く4=pygame.transform.scale(歩く4,(60,66))

#ネコの歩く画像リスト
ネコリスト=[歩く1,歩く2,歩く3,歩く4]
ネコ座標リスト=[]

#BGM
BGM=pygame.mixer.Sound("sound\BGM.mp3")
BGM.set_volume(0.03)
BGM.play(-1)

#転送
スクリーン.blit(背景,(0,0))
スクリーン.blit(城,(100,200))
スクリーン.blit(城_敵,(600,200))
スクリーン.blit(ネコボタン,(110,520))

#画像情報取得
ネコボタン情報=スクリーン.blit(ネコボタン,(110,520)) #rect(110, 520, 80, 65)が取得できる


"""ワンポイント解説
ネコボタン情報.collidepoint(110,520)
ネコボタン(110,520)の座標から右に80、下に65進んだ範囲がクリックされたかを調べている
True=1 False=0が返ってくる
"""

def ネコ出撃():
    global ネコ座標リスト #このリストは最初は空っぽで設定
    新しい座標= pygame.Rect(600,340,0,0)
    ネコ座標リスト.append(新しい座標)


#処理を終了させる
while True:
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit()
            sys.exit()
    
    #マウスの操作情報を取得する
    マウスクリック=pygame.mouse.get_pressed()
    #マウスカーソールの情報を取得する
    (mx,my)=pygame.mouse.get_pos()
    
    if マウスクリック[0] and ネコボタン情報.collidepoint((mx,my)) and プッシュフラグ==0:
        ネコ出撃()
        プッシュフラグ=1
    else:
        プッシュフラグ=0

    スクリーン.blit(背景,(0,0))
    スクリーン.blit(城,(100,200))
    スクリーン.blit(城_敵,(600,200))
    スクリーン.blit(ネコボタン,(110,520))

    for i in ネコ座標リスト: #ネコ座標リストから順番に取り出す
        if i.x > 180:
            i.x = i.x - 4
            番号=番号+1
            スクリーン.blit(ネコリスト[番号%4],i)

    
    #ディスプレイのアップデート
    pygame.display.update()
    #処理速度
    pygame.time.Clock().tick(5)
    

