import pygame,sys

#pygameの初期化
pygame.init()

#スクリーンの作成
スクリーン=pygame.display.set_mode((1000,305))

#画像ファイルのアップロード
ピアノ = pygame.image.load(r"image\ピアノ.png")
ド = pygame.image.load(r"image\ド.png")
レ = pygame.image.load(r"image\レ.png")
ミ = pygame.image.load(r"image\ミ.png")
ファ = pygame.image.load(r"image\ファ.png")
ソ = pygame.image.load(r"image\ソ.png")
ラ = pygame.image.load(r"image\ラ.png")
シ = pygame.image.load(r"image\シ.png")

#サウンドファイルのアップロード
ドの音=pygame.mixer.Sound(r"sound\ド.mp3")
レの音=pygame.mixer.Sound(r"sound\レ.mp3")
ミの音=pygame.mixer.Sound(r"sound\ミ.mp3")
ファの音=pygame.mixer.Sound(r"sound\ファ.mp3")
ソの音=pygame.mixer.Sound(r"sound\ソ.mp3")
ラの音=pygame.mixer.Sound(r"sound\ラ.mp3")
シの音=pygame.mixer.Sound(r"sound\シ.mp3")

#スクリーンに転送した画像を変数に格納　※当たり判定に使用する
鍵盤_ド=スクリーン.blit(ド,(280,0))
鍵盤_レ=スクリーン.blit(レ,(353,0))
鍵盤_ミ=スクリーン.blit(ミ,(422,0))
鍵盤_ファ=スクリーン.blit(ファ,(493,0))
鍵盤_ソ=スクリーン.blit(ソ,(566,0))
鍵盤_ラ=スクリーン.blit(ラ,(635,0))
鍵盤_シ=スクリーン.blit(シ,(705,0))

#鍵盤のクリック状態を管理するフラグ
プッシュフラグ=False

#関数定義
def 演奏():
    global プッシュフラグ
    
    #マウスのクリック状態を調べる※0は左クリック
    マウスクリック= pygame.mouse.get_pressed()
    
    #マウスの座標を調べる
    (mx,my) = pygame.mouse.get_pos()

    #ピアノ鍵盤を表示
    スクリーン.blit(ピアノ,(0,0))
    pygame.display.update()

    #マウスがクリックされたときの処理
    if マウスクリック[0] :
        #鍵盤_ドをクリックされたときの処理
        #マウスポインタの座標が鍵盤_ドの画像範囲にあり、かつプッシュフラグがFalseの時
        if 鍵盤_ド.collidepoint(mx,my)and プッシュフラグ == False:
            スクリーン.blit(ド,(280,0))
            ドの音.play()
            pygame.display.update()
            プッシュフラグ = True
        #マウスポインタの座標が鍵盤_レの画像範囲にあり、かつプッシュフラグがFalseの時
        elif 鍵盤_レ.collidepoint(mx,my)and プッシュフラグ == False:
            スクリーン.blit(レ,(353,0))
            レの音.play()
            pygame.display.update()
            プッシュフラグ = True
        #マウスポインタの座標が鍵盤_ミの画像範囲にあり、かつプッシュフラグがFalseの時
        elif 鍵盤_ミ.collidepoint(mx,my)and プッシュフラグ == False:
            ミの音.play()
            スクリーン.blit(ミ,(422,0))
            pygame.display.update()
            プッシュフラグ = True
        #マウスポインタの座標が鍵盤_ファの画像範囲にあり、かつプッシュフラグがFalseの時
        elif 鍵盤_ファ.collidepoint(mx,my)and プッシュフラグ == False:
            ファの音.play()
            スクリーン.blit(ファ,(493,0))
            pygame.display.update()
            プッシュフラグ = True
        #マウスポインタの座標が鍵盤_ソの画像範囲にあり、かつプッシュフラグがFalseの時
        elif 鍵盤_ソ.collidepoint(mx,my)and プッシュフラグ == False:
            ソの音.play()
            スクリーン.blit(ソ,(566,0))
            pygame.display.update()
            プッシュフラグ = True
        #マウスポインタの座標が鍵盤_ラの画像範囲にあり、かつプッシュフラグがFalseの時
        elif 鍵盤_ラ.collidepoint(mx,my)and プッシュフラグ == False:
            ラの音.play()
            スクリーン.blit(ラ,(635,0))
            pygame.display.update()
            プッシュフラグ = True
        #マウスポインタの座標が鍵盤_シの画像範囲にあり、かつプッシュフラグがFalseの時
        elif 鍵盤_シ.collidepoint(mx,my)and プッシュフラグ == False:
            シの音.play()
            スクリーン.blit(シ,(705,0))
            pygame.display.update()
            プッシュフラグ = True
    else:
        プッシュフラグ = False

while True:
    演奏()
    pygame.time.Clock().tick(20)

    for イベント in pygame.event.get():
        if イベント.type == pygame.QUIT:
            pygame.quit()
            sys.exit()
